<center><a href="modpcf.c">Actual source code: modpcf.c</a></center><br>

<html>
<head>
<title></title>
<meta name="generator" content="c2html 0.9.5">
<meta name="date" content="2007-03-29T00:29:32+00:00">
</head>

<body bgcolor="#FFFFFF">
<pre width="80"><a name="line1">  1: </a><strong><font color="#228B22">#define PETSCKSP_DLL</font></strong>

<a name="line3"> 3: </a> #include <A href="../../../../../../include/petscksp.h.html">petscksp.h</A>
<a name="line6">  6: </a><font color="#B22222">/*@C</font>
<a name="line7">  7: </a><font color="#B22222">   <A href="../../../../../../docs/manualpages/KSP/KSPFGMRESSetModifyPC.html#KSPFGMRESSetModifyPC">KSPFGMRESSetModifyPC</A> - Sets the routine used by FGMRES to modify the preconditioner.</font>

<a name="line9">  9: </a><font color="#B22222">   Collective on <A href="../../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A></font>

<a name="line11"> 11: </a><font color="#B22222">   Input Parameters:</font>
<a name="line12"> 12: </a><font color="#B22222">+  ksp - iterative context obtained from <A href="../../../../../../docs/manualpages/KSP/KSPCreate.html#KSPCreate">KSPCreate</A></font>
<a name="line13"> 13: </a><font color="#B22222">.  fcn - modifypc function</font>
<a name="line14"> 14: </a><font color="#B22222">.  ctx - optional contex</font>
<a name="line15"> 15: </a><font color="#B22222">-  d - optional context destroy routine</font>

<a name="line17"> 17: </a><font color="#B22222">   Calling Sequence of function:</font>
<a name="line18"> 18: </a><font color="#B22222">    int fcn(<A href="../../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> ksp,int total_its,int loc_its,<A href="../../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> res_norm,void*ctx);</font>

<a name="line20"> 20: </a><font color="#B22222">    ksp - the ksp context being used.</font>
<a name="line21"> 21: </a><font color="#B22222">    total_its     - the total number of FGMRES iterations that have occurred.    </font>
<a name="line22"> 22: </a><font color="#B22222">    loc_its       - the number of FGMRES iterations since last restart.</font>
<a name="line23"> 23: </a><font color="#B22222">    res_norm      - the current residual norm.</font>
<a name="line24"> 24: </a><font color="#B22222">    ctx           - optional context variable</font>

<a name="line26"> 26: </a><font color="#B22222">   Options Database Keys:</font>
<a name="line27"> 27: </a><font color="#B22222">   -ksp_fgmres_modifypcnochange</font>
<a name="line28"> 28: </a><font color="#B22222">   -ksp_fgmres_modifypcksp</font>

<a name="line30"> 30: </a><font color="#B22222">   Level: intermediate</font>

<a name="line32"> 32: </a><font color="#B22222">   Contributed by Allison Baker</font>

<a name="line34"> 34: </a><font color="#B22222">   Notes:</font>
<a name="line35"> 35: </a><font color="#B22222">   Several modifypc routines are predefined, including</font>
<a name="line36"> 36: </a><font color="#B22222">    <A href="../../../../../../docs/manualpages/KSP/KSPFGMRESModifyPCNoChange.html#KSPFGMRESModifyPCNoChange">KSPFGMRESModifyPCNoChange</A>()</font>
<a name="line37"> 37: </a><font color="#B22222">    <A href="../../../../../../docs/manualpages/KSP/KSPFGMRESModifyPCKSP.html#KSPFGMRESModifyPCKSP">KSPFGMRESModifyPCKSP</A>()</font>

<a name="line39"> 39: </a><font color="#B22222">.seealso: <A href="../../../../../../docs/manualpages/KSP/KSPFGMRESModifyPCNoChange.html#KSPFGMRESModifyPCNoChange">KSPFGMRESModifyPCNoChange</A>(), <A href="../../../../../../docs/manualpages/KSP/KSPFGMRESModifyPCKSP.html#KSPFGMRESModifyPCKSP">KSPFGMRESModifyPCKSP</A>()</font>

<a name="line41"> 41: </a><font color="#B22222">@*/</font>
<a name="line42"> 42: </a><strong><font color="#4169E1"><a name="KSPFGMRESSetModifyPC"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../../docs/manualpages/KSP/KSPFGMRESSetModifyPC.html#KSPFGMRESSetModifyPC">KSPFGMRESSetModifyPC</A>(<A href="../../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> ksp,<A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (*fcn)(<A href="../../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A>,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,void*),void* ctx,<A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (*d)(void*))</font></strong>
<a name="line43"> 43: </a>{
<a name="line44"> 44: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> ierr,(*f)(<A href="../../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A>,<A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (*)(<A href="../../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A>,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>,<A href="../../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>,void*),void*,<A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A> (*)(void*));

<a name="line48"> 48: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscObjectQueryFunction.html#PetscObjectQueryFunction">PetscObjectQueryFunction</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)ksp,<font color="#666666">"KSPFGMRESSetModifyPC_C"</font>,(void (**)(void))&amp;f);
<a name="line49"> 49: </a>  <font color="#4169E1">if</font> (f) {
<a name="line50"> 50: </a>    (*f)(ksp,fcn,ctx,d);
<a name="line51"> 51: </a>  }
<a name="line52"> 52: </a>  <font color="#4169E1">return</font>(0);
<a name="line53"> 53: </a>}


<a name="line56"> 56: </a><font color="#B22222">/* The following are different routines used to modify the preconditioner */</font>

<a name="line60"> 60: </a><font color="#B22222">/*@</font>

<a name="line62"> 62: </a><font color="#B22222">  <A href="../../../../../../docs/manualpages/KSP/KSPFGMRESModifyPCNoChange.html#KSPFGMRESModifyPCNoChange">KSPFGMRESModifyPCNoChange</A> - this is the default used by fgmres - it doesn't change the preconditioner. </font>

<a name="line64"> 64: </a><font color="#B22222">  Input Parameters:</font>
<a name="line65"> 65: </a><font color="#B22222">+    ksp - the ksp context being used.</font>
<a name="line66"> 66: </a><font color="#B22222">.    total_its     - the total number of FGMRES iterations that have occurred.    </font>
<a name="line67"> 67: </a><font color="#B22222">.    loc_its       - the number of FGMRES iterations since last restart.</font>
<a name="line68"> 68: </a><font color="#B22222">                    a restart (so number of Krylov directions to be computed)</font>
<a name="line69"> 69: </a><font color="#B22222">.    res_norm      - the current residual norm.</font>
<a name="line70"> 70: </a><font color="#B22222">-    dummy         - context variable, unused in this routine</font>

<a name="line72"> 72: </a><font color="#B22222">   Level: intermediate</font>

<a name="line74"> 74: </a><font color="#B22222">   Contributed by Allison Baker</font>

<a name="line76"> 76: </a><font color="#B22222">You can use this as a template!</font>

<a name="line78"> 78: </a><font color="#B22222">.seealso: <A href="../../../../../../docs/manualpages/KSP/KSPFGMRESSetModifyPC.html#KSPFGMRESSetModifyPC">KSPFGMRESSetModifyPC</A>(), <A href="../../../../../../docs/manualpages/KSP/KSPFGMRESModifyPCKSP.html#KSPFGMRESModifyPCKSP">KSPFGMRESModifyPCKSP</A>()</font>

<a name="line80"> 80: </a><font color="#B22222">@*/</font>
<a name="line81"> 81: </a><strong><font color="#4169E1"><a name="KSPFGMRESModifyPCNoChange"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../../docs/manualpages/KSP/KSPFGMRESModifyPCNoChange.html#KSPFGMRESModifyPCNoChange">KSPFGMRESModifyPCNoChange</A>(<A href="../../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> ksp,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> total_its,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> loc_its,<A href="../../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> res_norm,void* dummy)</font></strong>
<a name="line82"> 82: </a>{

<a name="line85"> 85: </a>  <font color="#4169E1">return</font>(0);
<a name="line86"> 86: </a>}

<a name="line90"> 90: </a><font color="#B22222">/*@</font>

<a name="line92"> 92: </a><font color="#B22222"> <A href="../../../../../../docs/manualpages/KSP/KSPFGMRESModifyPCKSP.html#KSPFGMRESModifyPCKSP">KSPFGMRESModifyPCKSP</A> - modifies the attributes of the</font>
<a name="line93"> 93: </a><font color="#B22222">     GMRES preconditioner.  It serves as an example (not as something </font>
<a name="line94"> 94: </a><font color="#B22222">     useful!) </font>

<a name="line96"> 96: </a><font color="#B22222">  Input Parameters:</font>
<a name="line97"> 97: </a><font color="#B22222">+    ksp - the ksp context being used.</font>
<a name="line98"> 98: </a><font color="#B22222">.    total_its     - the total number of FGMRES iterations that have occurred.    </font>
<a name="line99"> 99: </a><font color="#B22222">.    loc_its       - the number of FGMRES iterations since last restart.</font>
<a name="line100">100: </a><font color="#B22222">.    res_norm      - the current residual norm.</font>
<a name="line101">101: </a><font color="#B22222">-    dummy         - context, not used here</font>

<a name="line103">103: </a><font color="#B22222">   Level: intermediate</font>

<a name="line105">105: </a><font color="#B22222">   Contributed by Allison Baker</font>

<a name="line107">107: </a><font color="#B22222"> This could be used as a template!</font>

<a name="line109">109: </a><font color="#B22222">.seealso: <A href="../../../../../../docs/manualpages/KSP/KSPFGMRESSetModifyPC.html#KSPFGMRESSetModifyPC">KSPFGMRESSetModifyPC</A>(), <A href="../../../../../../docs/manualpages/KSP/KSPFGMRESModifyPCKSP.html#KSPFGMRESModifyPCKSP">KSPFGMRESModifyPCKSP</A>()</font>

<a name="line111">111: </a><font color="#B22222">@*/</font>
<a name="line112">112: </a><strong><font color="#4169E1"><a name="KSPFGMRESModifyPCKSP"></a><A href="../../../../../../docs/manualpages/Sys/PetscErrorCode.html#PetscErrorCode">PetscErrorCode</A>  <A href="../../../../../../docs/manualpages/KSP/KSPFGMRESModifyPCKSP.html#KSPFGMRESModifyPCKSP">KSPFGMRESModifyPCKSP</A>(<A href="../../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> ksp,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> total_its,<A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A> loc_its,<A href="../../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A> res_norm,void *dummy)</font></strong>
<a name="line113">113: </a>{
<a name="line114">114: </a>  <A href="../../../../../../docs/manualpages/PC/PC.html#PC">PC</A>             pc;
<a name="line116">116: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscInt.html#PetscInt">PetscInt</A>       maxits;
<a name="line117">117: </a>  <A href="../../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A>            sub_ksp;
<a name="line118">118: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscReal.html#PetscReal">PetscReal</A>      rtol,abstol,dtol;
<a name="line119">119: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscTruth.html#PetscTruth">PetscTruth</A>     isksp;

<a name="line122">122: </a>  <A href="../../../../../../docs/manualpages/KSP/KSPGetPC.html#KSPGetPC">KSPGetPC</A>(ksp,&amp;pc);

<a name="line124">124: </a>  <A href="../../../../../../docs/manualpages/Sys/PetscTypeCompare.html#PetscTypeCompare">PetscTypeCompare</A>((<A href="../../../../../../docs/manualpages/Sys/PetscObject.html#PetscObject">PetscObject</A>)pc,<A href="../../../../../../docs/manualpages/PC/PCKSP.html#PCKSP">PCKSP</A>,&amp;isksp);
<a name="line125">125: </a>  <font color="#4169E1">if</font> (isksp) {
<a name="line126">126: </a>    <A href="../../../../../../docs/manualpages/PC/PCKSPGetKSP.html#PCKSPGetKSP">PCKSPGetKSP</A>(pc,&amp;sub_ksp);
<a name="line127">127: </a>
<a name="line128">128: </a>    <font color="#B22222">/* note that at this point you could check the type of <A href="../../../../../../docs/manualpages/KSP/KSP.html#KSP">KSP</A> with <A href="../../../../../../docs/manualpages/KSP/KSPGetType.html#KSPGetType">KSPGetType</A>() */</font>

<a name="line130">130: </a>    <font color="#B22222">/* Now we can use functions such as <A href="../../../../../../docs/manualpages/KSP/KSPGMRESSetRestart.html#KSPGMRESSetRestart">KSPGMRESSetRestart</A>() or </font>
<a name="line131">131: </a><font color="#B22222">      <A href="../../../../../../docs/manualpages/KSP/KSPGMRESSetOrthogonalization.html#KSPGMRESSetOrthogonalization">KSPGMRESSetOrthogonalization</A>() or <A href="../../../../../../docs/manualpages/KSP/KSPSetTolerances.html#KSPSetTolerances">KSPSetTolerances</A>() */</font>

<a name="line133">133: </a>    <A href="../../../../../../docs/manualpages/KSP/KSPGetTolerances.html#KSPGetTolerances">KSPGetTolerances</A>(sub_ksp,&amp;rtol,&amp;abstol,&amp;dtol,&amp;maxits);
<a name="line134">134: </a>    <font color="#4169E1">if</font> (!loc_its) {
<a name="line135">135: </a>      rtol = .1;
<a name="line136">136: </a>    } <font color="#4169E1">else</font> {
<a name="line137">137: </a>      rtol *= .9;
<a name="line138">138: </a>    }
<a name="line139">139: </a>    <A href="../../../../../../docs/manualpages/KSP/KSPSetTolerances.html#KSPSetTolerances">KSPSetTolerances</A>(sub_ksp,rtol,abstol,dtol,maxits);
<a name="line140">140: </a>  }
<a name="line141">141: </a>  <font color="#4169E1">return</font>(0);
<a name="line142">142: </a>}




</pre>
</body>

</html>
